package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.SessionPolicy.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.SessionPolicyServiceCreateResponse != nil {
// handle response
}
}curl --request POST \
--url https://{tenantDomain}.conductor.one/api/v1/session-policies \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"displayName": "<string>",
"accessTokenTtlSeconds": 123,
"continuousDefaultOutcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"continuousRules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
],
"credentialDurations": [
{
"accessTokenTtlSeconds": 123,
"maxSessionDurationSeconds": 123
}
],
"idleTimeoutSeconds": 123,
"maxSessionDurationSeconds": 123,
"priority": 123,
"refreshRotationWindowSeconds": 123,
"refreshTokenTtlSeconds": 123,
"rotateRefreshOnUse": true,
"ssfReceive": {
"enabled": true,
"ssfReceiverStreamIds": [
"<string>"
]
},
"ssfTransmit": {
"enabled": true,
"eventTypes": [
"<string>"
],
"ssfTransmitterStreamIds": [
"<string>"
]
}
}
'import requests
url = "https://{tenantDomain}.conductor.one/api/v1/session-policies"
payload = {
"displayName": "<string>",
"accessTokenTtlSeconds": 123,
"continuousDefaultOutcome": {
"allow": {},
"challengeRequired": { "types": [] },
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": { "credentialTypes": [] },
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"continuousRules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": { "types": [] },
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": { "credentialTypes": [] },
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
],
"credentialDurations": [
{
"accessTokenTtlSeconds": 123,
"maxSessionDurationSeconds": 123
}
],
"idleTimeoutSeconds": 123,
"maxSessionDurationSeconds": 123,
"priority": 123,
"refreshRotationWindowSeconds": 123,
"refreshTokenTtlSeconds": 123,
"rotateRefreshOnUse": True,
"ssfReceive": {
"enabled": True,
"ssfReceiverStreamIds": ["<string>"]
},
"ssfTransmit": {
"enabled": True,
"eventTypes": ["<string>"],
"ssfTransmitterStreamIds": ["<string>"]
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
displayName: '<string>',
accessTokenTtlSeconds: 123,
continuousDefaultOutcome: {
allow: {},
challengeRequired: {types: []},
deny: {reasonAdmin: '<string>', reasonUser: '<string>'},
enrollmentRequired: {credentialTypes: []},
stepUpRequired: {maxAgeSeconds: 123, types: []}
},
continuousRules: [
{
description: '<string>',
id: '<string>',
matchCel: '<string>',
outcome: {
allow: {},
challengeRequired: {types: []},
deny: {reasonAdmin: '<string>', reasonUser: '<string>'},
enrollmentRequired: {credentialTypes: []},
stepUpRequired: {maxAgeSeconds: 123, types: []}
}
}
],
credentialDurations: [{accessTokenTtlSeconds: 123, maxSessionDurationSeconds: 123}],
idleTimeoutSeconds: 123,
maxSessionDurationSeconds: 123,
priority: 123,
refreshRotationWindowSeconds: 123,
refreshTokenTtlSeconds: 123,
rotateRefreshOnUse: true,
ssfReceive: {enabled: true, ssfReceiverStreamIds: ['<string>']},
ssfTransmit: {enabled: true, eventTypes: ['<string>'], ssfTransmitterStreamIds: ['<string>']}
})
};
fetch('https://{tenantDomain}.conductor.one/api/v1/session-policies', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"sessionPolicy": {
"accessTokenTtlSeconds": 123,
"continuousDefaultOutcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
},
"continuousRules": [
{
"description": "<string>",
"id": "<string>",
"matchCel": "<string>",
"outcome": {
"allow": {},
"challengeRequired": {
"types": []
},
"deny": {
"reasonAdmin": "<string>",
"reasonUser": "<string>"
},
"enrollmentRequired": {
"credentialTypes": []
},
"stepUpRequired": {
"maxAgeSeconds": 123,
"types": []
}
}
}
],
"createdAt": "2023-11-07T05:31:56Z",
"credentialDurations": [
{
"accessTokenTtlSeconds": 123,
"maxSessionDurationSeconds": 123
}
],
"deletedAt": "2023-11-07T05:31:56Z",
"displayName": "<string>",
"id": "<string>",
"idleTimeoutSeconds": 123,
"isBuiltin": true,
"maxSessionDurationSeconds": 123,
"priority": 123,
"refreshRotationWindowSeconds": 123,
"refreshTokenTtlSeconds": 123,
"rotateRefreshOnUse": true,
"ssfReceive": {
"enabled": true,
"ssfReceiverStreamIds": [
"<string>"
]
},
"ssfTransmit": {
"enabled": true,
"eventTypes": [
"<string>"
],
"ssfTransmitterStreamIds": [
"<string>"
]
},
"updatedAt": "2023-11-07T05:31:56Z"
}
}Create
Create a session policy.
package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.SessionPolicy.Create(ctx, nil)
if err != nil {
log.Fatal(err)
}
if res.SessionPolicyServiceCreateResponse != nil {
// handle response
}
}Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
This API uses OAuth2 with the Client Credential flow. Client Credentials must be sent in the BODY, not the headers. For an example of how to implement this, refer to the c1TokenSource.Token() function.
Body
The SessionPolicyServiceCreateRequest message.
The displayName field.
The accessTokenTtlSeconds field.
PolicyOutcome is the effect of a matched rule. Exactly one kind is set. For session continuous-evaluation, the meaningful kinds are Allow (continue), Deny (terminate), and StepUpRequired.
This message contains a oneof named kind. Only a single field of the following list may be set at a time:
- allow
- deny
- stepUpRequired
- challengeRequired
- enrollmentRequired
Show child attributes
Show child attributes
The continuousRules field.
Show child attributes
Show child attributes
The credentialDurations field.
Show child attributes
Show child attributes
The idleTimeoutSeconds field.
The maxSessionDurationSeconds field.
The persistence field.
PERSISTENCE_MODE_UNSPECIFIED, PERSISTENCE_MODE_ALLOW_USER_CHOICE, PERSISTENCE_MODE_ALWAYS_PERSIST, PERSISTENCE_MODE_SESSION_ONLY The priority field.
The refreshRotationWindowSeconds field.
The refreshTokenTtlSeconds field.
The rotateRefreshOnUse field.
SSFReceiverConfig selects which inbound shared-signals streams this session trusts. Each stream's issuer, keys, expected audience, and per-event actions are configured on the stream itself; this policy just lists the stream IDs.
Show child attributes
Show child attributes
SSFTransmitterConfig selects which outbound shared-signals streams this session emits security events to. Each stream's delivery endpoint, authentication, and per-event allowlist are configured on the stream itself; this policy just lists the stream IDs and the event types to emit.
Show child attributes
Show child attributes
Response
Successful response
The SessionPolicyServiceCreateResponse message.
SessionPolicy defines session lifetime and continuous-evaluation behavior.
Show child attributes
Show child attributes
Was this page helpful?